(*Ŀ
$ Source $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
$$$$$$$  $  $$$  $$$  $  $    $$$$   $$$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$   $   $$     $$   $   $  $o  $'  $   $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$   $   $$  $  $$   $   $  $7 $  $$$  $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$       $$     $$$     $$    $$  $$$  $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$   $   $   $   $$$   $$$  $$$$$   $   $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$  $  $ $$$ $$$  $$$ $$$$$$    $$$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
$ http://www.haypo.fr.st/ $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$ haypo@ifrance.com $
Ĵ
  Info                                                                    
                                                                    
                                                                            
 Programme de dessin proposant de nombreux outils : point, cercle, ligne,   
 disque, rectangle, rectangle plein, et les mmes outils produisant des     
 rsultats alatoires.                                                      
*)

{$M 4096,0,128000}

{-$DEFINE Vesa: Utilise VESA                                                 }

uses Clavier,DrvSouri,EcranTXT,
{$IFDEF Vesa}Vesa2,SouriVSA{$ELSE}EcranVGA,SouriVGA{$ENDIF};

const
  { Les diffrents outils (n'oubliez pas de modifier les procdures }
  { 'UtiliseOutil', 'AfficheNomOutil' et 'ModifieOutil')            }
  NbrOutil  = 13;

  _Point    = 1;
  _Ligne    = 2;
  _Cercle   = 3;
  _Disque   = 4;
  _Rect     = 5;
  _RectP    = 6;
  _Gomme    = 7;
  _PointXY  = 8;
  _LigneXY  = 9;
  _CercleXY = 10;
  _DisqueXY = 11;
  _RectXY   = 12;
  _RectPXY  = 13;

  { Barre d'avancement }
  LargBarAvance = 20;
  HautBarAvance = 150;

  { Valeurs minimales, par dfaut, et maximales (en pixel) }
  RayonMin =   1;
  RayonDef =  40;
  RayonMax = 200;

  RayonDisqMin =   2;
  RayonDisqDef =  40;
  RayonDisqMax = 200;

  LigneMin = 2;
  LigneDef = 100;
  LigneMax = 320;

  GommeMin =   1;
  GommeDef = 100;
  GommeMax = 400;

  RectMin =   2;
  RectDef = 100;
  RectMax = 320;

var
  TypeOutil : record
    Index: Word;

    { Option des outils }
    Rayon: Word;                       { Rayon des cercles tracs            }
    RayonDisq: Word;                   { Rayon max des disques tracs        }
    LongLigne: Word;                   { Longueurs maximales des lignes      }
    LargRect: Word;                    { Largeur/hauteur maximale d'un rect. }
    LargRectP: Word;                   { Largeur/hauteur maximale d'un       }
                                       { rectangle plein                     }
    LargGomme: Word;                   { Largeur du rectangle de gommage     }

    ValMax,Min,Max: Word;
  end;
  CoulFond: Byte;

  TmpX,TmpY: LongInt;
  Larg,Haut: Word;
  Coul: Byte;

  txt: String;
  {$IFNDEF Vesa}TamponEcran,{$ENDIF}SauveEcran: PtrImage;
  ch: Char;

  BarreX,BarreY: Word;
  TxtX,TxtY: Word;

procedure Fin; begin
  { Retour au mode texte }
  ModeTxt;

  {$IFNDEF Vesa}
    { Libre la mmoire alloue }
    Dispose (TamponEcran);
  {$ENDIF}
  Dispose (SauveEcran);

  Halt;
end;

procedure Init; begin
  { Alloue de la mmoire }
  if MemAvail < 64000{$IFNDEF Vesa}*2{$ENDIF} then begin
    EffaceEcranTxt;
    EcriTcr ('Pas assez de mmoire libre pour crer un double buffer !',14+4*16);
    Ecrit ('(il manque '); EcriTnc (64000{$IFNDEF Vesa}*2{$ENDIF}-MemAvail,10); EcriTr (' octets)');
    SauteLigne;
    Halt (8);
  end;
  GetMem (SauveEcran,64000);
  {$IFNDEF Vesa}
  GetMem (TamponEcran,64000); ChangeDestEcran (TamponEcran); EffaceEcran (0);
  {$ENDIF}

  { Vrifie la prsence du pilote de la souris, et de la souris }
  txt := DetectSouris;
  if txt<>'' then begin
    WriteLn ('Erreur lors de la detection de la souris : ');
    Writeln (txt);
    Writeln;
    Halt (1);
  end;

  { Lance le mode vido VGA }
  {$IFDEF Vesa}
    LanceMode (320,200,8);
  {$ELSE}
    ModeVga256;
  {$ENDIF}
  Randomize;

  { Ecrit un peu de texte }
  {$IFDEF Vesa}EcriTsp8{$ELSE}EcriTsp{$ENDIF}
    (-1,8*0,'Clic gauche pour dessiner',15);
  {$IFDEF Vesa}EcriTsp8{$ELSE}EcriTsp{$ENDIF}
    (-1,8*1,'Clic droit pour modifier l''outil',15);
  {$IFDEF Vesa}EcriTsp8{$ELSE}EcriTsp{$ENDIF}
    (-1,8*2,'Espace pour changer d''outil',15);
  {$IFDEF Vesa}EcriTsp8{$ELSE}EcriTsp{$ENDIF}
    (-1,8*3,'Entre pour effacer l''cran',15);
  {$IFDEF Vesa}EcriTsp8{$ELSE}EcriTsp{$ENDIF}
    (-1,200-8,'Echape pour quitter',12);

  { Initialise la souris, puis la dessine }
  InitSouris;
  DessineSouris;

  { Initialise le type de dessin }
  with TypeOutil do begin
    Index := _DisqueXY;
    Rayon     := RayonDef;
    RayonDisq := RayonDisqDef;
    LongLigne := LigneDef;
    LargGomme := GommeDef;
    LargRect  := RectDef;
    LargRectP := LargRect;
  end;
end;

procedure UtiliseOutil; var Xok,Yok: Word; begin with TypeOutil do begin
  EffaceSouris;
  Souris.DessinAuto := FALSE;
  {$IFDEF Vesa}LitBlocOfs8(0,64000,SauveEcran^){$ELSE}CopiePtr(Ecran,SauveEcran){$ENDIF};
  Coul := Random(256);
  TmpX := Souris.X;
  TmpY := Souris.Y;

  Case Index of
  _CercleXY,_DisqueXY: begin
    SauvePosSouris;
    Souris.X := 0;
    Souris.Y := 0;
  end end;

  repeat
    VideTamponClavier;   { Ignore les touches presses }
    LitSouris;
    Case Index of
    _Point: {$IFDEF Vesa} DessinePoint8 {$ELSE} DessinePoint {$ENDIF}
              (Souris.X,Souris.Y,Random(256));
    _PointXY: begin
      {$IFDEF Vesa} EcritBlocOfs8 (0,64000,SauveEcran^);
      {$ELSE} CopiePtr (SauveEcran,TamponEcran);{$ENDIF}

      {$IFDEF Vesa} DessinePoint8 {$ELSE} DessinePoint {$ENDIF}
        (Souris.X,Souris.Y,Coul);
    end;
    _Cercle: {$IFDEF Vesa} DessineCercle8 {$ELSE} DessineCercle {$ENDIF}
               (Souris.X,Souris.Y,Random(Rayon),Random(256));
    _CercleXY: begin
      {$IFDEF Vesa} EcritBlocOfs8 (0,64000,SauveEcran^);
      {$ELSE} CopiePtr (SauveEcran,TamponEcran);{$ENDIF}

      Larg := Souris.Y;
      if Larg=0 then Larg := 1;
      {$IFDEF Vesa} DessineCercle8 {$ELSE} DessineCercle {$ENDIF}
        (TmpX,TmpY,Larg,Coul);
    end;
    _Disque: {$IFDEF Vesa} DessineDisque8 {$ELSE} DessineDisque {$ENDIF}
               (Souris.X,Souris.Y,Random(RayonDisq),Random(256));
    _DisqueXY: begin
      {$IFDEF Vesa} EcritBlocOfs8 (0,64000,SauveEcran^);
      {$ELSE} CopiePtr (SauveEcran,TamponEcran);{$ENDIF}

      Larg := Souris.Y;
      if Larg=0 then Larg := 1;
      if RayonDisqMax<Larg then Larg := RayonDisqMax;
      {$IFDEF Vesa} DessineDisque8 {$ELSE} DessineDisque {$ENDIF}
        (TmpX,TmpY,Larg,Coul);
    end;
    _Ligne: begin
      TmpX := Random(LongLigne); if Random(2)=1 then TmpX := -TmpX;
      TmpY := Random(LongLigne); if Random(2)=1 then TmpY := -TmpY;
      {$IFDEF Vesa} DessineLigne8 {$ELSE} DessineLigne {$ENDIF}
        (Souris.X,Souris.Y,Souris.X+TmpX,Souris.Y+TmpY,Random(256));
    end;
    _LigneXY: begin
      {$IFDEF Vesa} EcritBlocOfs8 (0,64000,SauveEcran^);
      {$ELSE} CopiePtr (SauveEcran,TamponEcran);{$ENDIF}

      { Dessine la ligne }
      {$IFDEF Vesa} DessineLigne8 {$ELSE} DessineLigne {$ENDIF}
        (TmpX,TmpY,Souris.X,Souris.Y,Coul);
    end;
    _Rect: begin
      TmpX := Random(LargRect);
      TmpY := Random(LargRect);
      {$IFDEF Vesa} DessineRectangle8 {$ELSE} DessineRectangle {$ENDIF}
        (Souris.X-TmpX shr 1,Souris.Y-TmpY shr 1,TmpX,TmpY,Random(256));
    end;
    _RectXY: begin
      {$IFDEF Vesa} EcritBlocOfs8 (0,64000,SauveEcran^);
      {$ELSE} CopiePtr (SauveEcran,TamponEcran);{$ENDIF}

      if Souris.X<TmpX then Xok := Souris.X else Xok := TmpX;
      if Souris.Y<TmpY then Yok := Souris.Y else Yok := TmpY;
      Larg := Abs(Souris.X+1-TmpX); if Larg=0 then Larg := 1;
      Haut := Abs(Souris.Y+1-TmpY); if Haut=0 then Haut := 1;
      {$IFDEF Vesa} DessineRectangle8 {$ELSE} DessineRectangle {$ENDIF}
        (Xok,Yok,Larg,Haut,Coul);
    end;
    _RectP: begin
      TmpX := Random(LargRectP);
      TmpY := Random(LargRectP);
      {$IFDEF Vesa} DessineRectanglePlein8 {$ELSE} DessineRectanglePlein {$ENDIF}
        (Souris.X-TmpX shr 1,Souris.Y-TmpY shr 1,TmpX,TmpY,Random(256));
    end;
    _RectPXY: begin
      {$IFDEF Vesa} EcritBlocOfs8 (0,64000,SauveEcran^);
      {$ELSE} CopiePtr (SauveEcran,TamponEcran);{$ENDIF}

      if Souris.X<TmpX then Xok := Souris.X else Xok := TmpX;
      if Souris.Y<TmpY then Yok := Souris.Y else Yok := TmpY;
      Larg := Abs(Souris.X+1-TmpX); if Larg=0 then Larg := 1;
      Haut := Abs(Souris.Y+1-TmpY); if Haut=0 then Haut := 1;
      {$IFDEF Vesa} DessineRectanglePlein8 {$ELSE} DessineRectanglePlein {$ENDIF}
        (Xok,Yok,Larg,Haut,Coul);
    end;
    _Gomme: {$IFDEF Vesa} DessineRectanglePlein8 {$ELSE} DessineRectanglePlein {$ENDIF}
              (LongInt(Souris.X)-LargGomme shr 1,LongInt(Souris.Y)-LargGomme shr 1,
               LargGomme,LargGomme, CoulFond);
    end;

    { Affiche le tampon d'cran }
    {$IFDEF Vesa}
    AttendEcran;
    ChangePageVideo;
    EcritPageSuivante;
    {$ELSE}
    AttendEcran;
    AfficheEcran;
    {$ENDIF}
  until Souris.B1=FALSE;

  Souris.DessinAuto := TRUE;
  if (Index=_CercleXY) or (Index=_DisqueXY) then RemetPosSouris;
  if Souris.B2 then {$IFDEF Vesa}EcritBlocOfs8 (0,64000,SauveEcran^);{$ELSE}CopiePtr (SauveEcran,TamponEcran);{$ENDIF}
  DessineSouris;
  {$IFDEF Vesa}
    ChangePageVideo;
    EcritPageSuivante;
  {$ELSE}
    AfficheEcran;
  {$ENDIF}
  if Souris.B2 then AttendBoutonSouris (2);
end end;

procedure AfficheNomOutil; var larg,haut: Word; begin
  { Cre une description de l'outil }
  Case TypeOutil.index of
  _Point   : txt := 'Trac alatoire de points';
  _PointXY : txt := 'Trac de point';
  _Cercle  : txt := 'Dessin alatoire de cercles';
  _CercleXY: txt := 'Dessin de cercle';
  _Disque  : txt := 'Dessin alatoire de disques';
  _DisqueXY: txt := 'Dessin de disque';
  _Ligne   : txt := 'Dessin alatoire de lignes';
  _LigneXY : txt := 'Dessin de ligne';
  _Rect    : txt := 'Dessin alatoire de rectangles';
  _RectXY  : txt := 'Dessin de rectangle';
  _RectP   : txt := 'Dessin a. de rectangles pleins';
  _RectPXY : txt := 'Dessin de rectangles plein';
  _Gomme   : txt := 'Outil gomme';
  end;
  txt := ' '+txt+' ';

  { Dessine une fentre }
  larg := (length(txt)+1)*8;
  haut := 2*8;
  {$IFDEF Vesa} DessineRectanglePlein8 {$ELSE} DessineRectanglePlein {$ENDIF}
    ((320-larg) shr 1,(200-haut) shr 1,larg,haut,1);
  {$IFDEF Vesa} DessineRectangle8 {$ELSE} DessineRectangle {$ENDIF}
    ((320-larg) shr 1,(200-haut) shr 1,larg,haut,14);

  { Ecrit le nom de l'outil }
  {$IFDEF Vesa}EcriTsp8{$ELSE}EcriTsp{$ENDIF}
    (-1,-1,txt,15);
end;

procedure AttendActionUtilisateur; begin with Souris do begin
  SauvePosSouris;
  repeat
    AttendEcran;
    LitSouris;
    {$IFDEF Vesa}
      ChangePageVideo;
      EcritPageSuivante;
    {$ELSE}
      AfficheEcran;
    {$ENDIF}
  until TouchPresse or B1 or B2 or (0<Souris.PlusX) or (0<Souris.PlusY);
  RemetPosSouris;

  if TouchPresse then LitTouche
  else if B1 then AttendBoutonSouris (1)
  else if B2 then AttendBoutonSouris (2);
end end;

procedure ChangeOutil; var X,Y: Word; begin with TypeOutil do begin
  { Change d'outil }
  if index=NbrOutil then index := 0;
  inc (index);

  { Sauve le fond }
  {$IFDEF Vesa}LitBlocOfs8(0,64000,SauveEcran^){$ELSE}CopiePtr(Ecran,SauveEcran){$ENDIF};

  { Affiche le nom de l'outil }
  AfficheNomOutil;

  { Affiche le tampon d'cran }
  AttendEcran;
  {$IFDEF Vesa}
    ChangePageVideo;
    EcritPageSuivante;
  {$ELSE}
    AfficheEcran;
  {$ENDIF}

  { Attend une action de l'utilisateur (clavier ou souris }
  AttendActionUtilisateur;

  { Remet l'ancien fond }
  {$IFDEF Vesa} EcritBlocOfs8 (0,64000,SauveEcran^);
  {$ELSE} CopiePtr (SauveEcran,TamponEcran);{$ENDIF}
  AttendEcran;
  {$IFDEF Vesa}
    ChangePageVideo;
    EcritPageSuivante;
  {$ELSE}
    AfficheEcran;
  {$ENDIF}
end end;

procedure PrepareBarreAvancement (X,Y: Word; TxtTitre: String; Avancement: Word); begin with TypeOutil do begin
  { Affiche le texte : 'Rayon = xxx' }
  Str (Avancement:3,txt); txt := TxtTitre+txt+' pixels';
  {$IFDEF Vesa}EcriTxt8{$ELSE}EcriVga{$ENDIF}
    (X,Y,txt,15,0);
  TxtX := X+length(TxtTitre)*8; TxtY := Y;

  { Dessine la barre d'avancement }
  BarreX := X+2; BarreY := Y+8 +2;
  {$IFDEF Vesa} DessineRectanglePlein8 {$ELSE} DessineRectanglePlein {$ENDIF}
    (BarreX,BarreY,LargBarAvance,HautBarAvance,10);
  Souris.Y := LongInt(Avancement)*ValMax div Max;

  {$IFDEF Vesa}EcriTsp8{$ELSE}EcriTsp{$ENDIF}
    (-1,200-8*2,'Modifiez cette valeur en bougeant votre souris de bas en haut',15);
end end;

function ModifBarreAvancement : Word; var Avance: Word; begin with TypeOutil do begin
  { Calcule l'avancement, puis l'affiche }
  Avance := Min +LongInt(Souris.Y)*(Max-Min) div ValMax;
  Str (Avance:3,txt);
  {$IFDEF Vesa}EcriTxt8{$ELSE}EcriVga{$ENDIF}
    (TxtX,TxtY,txt,15,0);

  { Renvoie l'avancement calcul }
  ModifBarreAvancement := Avance;

  { Dessine la barre d'avancement }
  Avance := LongInt(Souris.Y)*HautBarAvance div ValMax;
  {$IFDEF Vesa} DessineRectanglePlein8 {$ELSE} DessineRectanglePlein {$ENDIF}
    (BarreX,BarreY,LargBarAvance,Avance,14);
  {$IFDEF Vesa} DessineRectanglePlein8 {$ELSE} DessineRectanglePlein {$ENDIF}
    (BarreX,BarreY+Avance,LargBarAvance,HautBarAvance-Avance,1);
end end;

procedure ModifieOutil; begin with TypeOutil do begin
  { Sauve le fond }
  EffaceSouris;
  Souris.DessinAuto := FALSE;
  {$IFDEF Vesa}LitBlocOfs8(0,64000,SauveEcran^){$ELSE}CopiePtr(Ecran,SauveEcran){$ENDIF};

  { Affiche le nom de l'outil }
  {$IFDEF Vesa} EffaceEcranVesa {$ELSE} EffaceEcran {$ENDIF}
    (0);
  AfficheNomOutil;

  { Prparation du modificateur }
  SauvePosSouris;
  ValMax := 199;    { Y de la souris : de 0  199 }
  Case Index of
  _Cercle: begin
    Min := RayonMin;
    Max := RayonMax;
    PrepareBarreAvancement (0,0,'Rayon cercle max = ',Rayon);
  end;
  _Disque: begin
    Min := RayonDisqMin;
    Max := RayonDisqMax;
    PrepareBarreAvancement (0,0,'Rayon disque max = ',RayonDisq);
  end;
  _Ligne: begin
    Min := LigneMin;
    Max := LigneMax;
    PrepareBarreAvancement (0,0,'Longueur max ligne = ',LongLigne);
  end;
  _Rect: begin
    Min := RectMin;
    Max := RectMax;
    PrepareBarreAvancement (0,0,'Largeur max rectangle = ',LargRect);
  end;
  _RectP: begin
    Min := RectMin;
    Max := RectMax;
    PrepareBarreAvancement (0,0,'Largeur max rectangle plein = ',LargRectP);
  end;
  _Gomme: begin
    Min := GommeMin;
    Max := GommeMax;
    PrepareBarreAvancement (0,0,'Largeur de la gomme = ',LargGomme);
  end end;

  { Affiche le tampon d'cran }
  AttendEcran;
  {$IFDEF Vesa}
    ChangePageVideo;
    EcritPageSuivante;
  {$ELSE}
    AfficheEcran;
  {$ENDIF}

  { Modification de l'outil }
  repeat
    LitSouris;

    Case Index of
    _Cercle: Rayon     := ModifBarreAvancement;
    _Disque: RayonDisq := ModifBarreAvancement;
    _Ligne : LongLigne := ModifBarreAvancement;
    _Rect  : LargRect  := ModifBarreAvancement;
    _RectP : LargRectP := ModifBarreAvancement;
    _Gomme : LargGomme := ModifBarreAvancement;
    end;

    { Affiche le tampon d'cran }
    AttendEcran;
    {$IFDEF Vesa}
      ChangePageVideo;
      EcritPageSuivante;
    {$ELSE}
      AfficheEcran;
    {$ENDIF}
  until not Souris.B2;

  { Remet l'ancien fond }
  {$IFDEF Vesa} EcritBlocOfs8 (0,64000,SauveEcran^);
  {$ELSE} CopiePtr (SauveEcran,TamponEcran);{$ENDIF}
  RemetPosSouris;
  Souris.DessinAuto := TRUE;
  DessineSouris;
  { Affiche le tampon d'cran }
  AttendEcran;
  {$IFDEF Vesa}
    ChangePageVideo;
    EcritPageSuivante;
  {$ELSE}
    AfficheEcran;
  {$ENDIF}
end end;


begin
  Init;

  repeat
    LitSouris;
    if Souris.B1 then UtiliseOutil;
    if Souris.B2 then ModifieOutil;

    if TouchPresse then begin
      ch := LitTouche;
      Case ch of
      _ESPACE: begin
        Souris.DessinAuto := FALSE;
        EffaceSouris;
        while ch=_ESPACE do begin
          ChangeOutil;
          if TouchPresse then
            ch := LitTouche
          else
            ch := #0;
        end;
        Souris.DessinAuto := TRUE;
        DessineSouris;
    {$IFDEF Vesa}
      ChangePageVideo;
      EcritPageSuivante;
    {$ELSE}
      AfficheEcran;
    {$ENDIF}
      end;
      _ENTREE: begin
        CoulFond := Random(256);
        {$IFDEF Vesa} EffaceEcranVesa {$ELSE} EffaceEcran {$ENDIF}
          (CoulFond);
        DessineSouris;
      end end;
    end;

    AttendEcran;
    {$IFDEF Vesa}
EcritPageSuivante;
      ChangePageVideo;
    {$ELSE}
      AfficheEcran;
    {$ENDIF}
  until ch=_ECHAPE;

  Fin;
end.